﻿package  {
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.ColorMatrixFilter;
	import flash.text.TextField;
	import flash.utils.getTimer;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.view.BasicView;
	import org.papervision3d.view.layer.ViewportLayer;

	/**
	 * 3D View
	 */
	public class World extends BasicView{
		private var sphere1:Sphere;
		private var sphere_layer:ViewportLayer;
		private var box:Cube;

		/**
		 * コンストラクタ
		 */
		public function World() {

			//初期化
			init();
			//フレームレート表示
			showFPS();
		}

		public function init() {
			//ライブラリにリンケージしてあるビットマップデータ
			var bmd = new TextureBitmapData(256, 256);
			//------------------------
			//球体のマテリアル
			var bitmapMaterial:BitmapMaterial = new BitmapMaterial(bmd);
			bitmapMaterial.smooth = true;
			//球体
			sphere1 = new Sphere(bitmapMaterial, 50);
			scene.addChild(sphere1);
			sphere_layer = viewport.getChildLayer(sphere1);
			//------------------------
			//立方体
			box = new Cube(new MaterialsList( { all:bitmapMaterial } ), 100, 100, 100,4,4,4);
			scene.addChild(box);
			//------------------------
			//カメラ位置調整
			camera.fov = 30;
			camera.y = 200;
			camera.z = -800;
			camera.target = box;
			//描画開始
			startRendering();
		}

		override protected function onRenderTick(event:Event = null):void {
			//球体を回転させる
			sphere1.rotationY += 1;
			sphere1.x = mouseX - 300;
			box.rotationY += 1;
			if (sphere1.hitTestObject(box)) {
				//接触している
				sphere_layer.filters = [new ColorMatrixFilter( [1, 0, 0, 0, 255,0, 1, 0, 0, 0,0, 0, 1, 0, 0,0, 0, 0, 1, 0])];
			}else {
				//接触していない
				sphere_layer.filters = [new ColorMatrixFilter( [1, 0, 0, 0, 0,0, 1, 0, 0, 0,0, 0, 1, 0, 0,0, 0, 0, 1, 0])];
			}

			super.onRenderTick();
		}
		
		//---------------------------
		//以下、フレームレート計算用
		private	var fps_text:TextField = new TextField();
		private var update_time = 500;
		private	var draw_count = 0;
		private	var old_timer = getTimer();
		private function showFPS():void{
			fps_text.background = true;
			fps_text.selectable = false;
			fps_text.width = 70;
			fps_text.height = 18;
			this.addChild (fps_text);
			this.addEventListener(Event.ENTER_FRAME , onFPS);
		}
		private function onFPS(e:Event):void{
			draw_count += 1;
			if (getTimer()-old_timer >= update_time) {
				var fps = draw_count * 1000 / (getTimer() - old_timer);
				fps = Math.floor(fps * 10) / 10;  
				fps_text.text ="FPS:"+ fps + ' / ' + fps_text.stage.frameRate;
				old_timer = getTimer();
				draw_count = 0;
			}
		}
	}
}
